<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Task72.40</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css" />
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  <style>
    i {
      cursor: pointer;
    }
  </style>
</head>

<body>
  <div class="wrapper">

    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search"
                  aria-label="Search" />
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside style="min-height: 100vh;" class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="info">
          <a href="#" class="d-block text-center">DEV CAMP</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-th"></i>
              <p>
                Manage
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="voucher.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="menu.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="drink.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="region.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order</p>
                </a>
              </li>
            </ul>
          </li>
          <!--  -->
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
  </div>
  <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Region</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Region</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">

        <h2 style="text-align: center">Quản lý region</h2>
        <div class="jumbotron container">
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="">Chọn quốc gia</label>
            </div>
            <div class="col-sm-9">
              <select name="" id="select-country" class="form-control">
                <option value="0">Chọn quốc gia</option>
              </select>
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="region-code">Mã vùng miền</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-region-Code" name="discount" placeholder="Region Code"
                class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="region-code">Tên vùng miền</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-region-name" placeholder="Region Name" class="form-control" />
            </div>
          </div>
          <div class="row mb-3 pull-right">
            <div class="col-sm-12 d-flex justify-content-around">
              <button class="btn btn-primary" id="create-country">
                Create Country
              </button>
              <button id="update-country" class="btn btn-info">
                Update Country
              </button>
              <button class="btn btn-danger" id="delete-country">
                Delete Country
              </button>
              <button class="btn btn-danger" id="delete-all-country">
                Delete ALL Country
              </button>
            </div>
          </div>
          <div class="row pull-right">
            <div class="col-sm-12 d-flex justify-content-around">
              <button class="btn btn-primary" id="create-region">
                Create Region
              </button>
              <button id="update-region" class="btn btn-info">
                Update Region
              </button>
              <button class="btn btn-danger" id="delete-region">
                Delete Region
              </button>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover text-center" id="region-table">
          <thead>
            <tr>
              <th>Region Id</th>
              <th>Region Code</th>
              <th>Region Name</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
        <!-- Modal delete region-->
        <div class="modal fade" id="modal-delete-region">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-danger">Xác nhận xóa region</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <h6 class="text-danger">Bạn có chác muốn xóa region</h6>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                <button type="button" class="btn btn-danger" id="button-delete-region">
                  Delete
                </button>
              </div>
            </div>
          </div>
        </div>
        <!-- Modal create-->
        <div class="modal fade" id="modal-create-country">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-primary">Manage Country</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="country-code">Mã Đất nước</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-country-code" placeholder="Country Code" class="form-control" />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="country-name">Tên đất nước</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-country-name" placeholder="Country Name" class="form-control" />
                  </div>
                </div>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                <button type="button" class="btn btn-primary" id="btn-save-country">
                  Save Data
                </button>
              </div>
            </div>
          </div>
        </div>

        <!-- Modal update-->
        <div class="modal fade" id="modal-update-country">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-primary">Update Country</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="country-code">Mã Đất nước</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-country-code-update" placeholder="Country Code" class="form-control" />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="country-name">Tên đất nước</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-country-name-update" placeholder="Country Name" class="form-control" />
                  </div>
                </div>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-primary" id="btn-update-country">
                  Update
                </button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Cancel
                </button>
                
              </div>
            </div>
          </div>
        </div>
        <!-- Modal delete department-->
        <div class="modal hide" id="modal-delete-country">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-danger">Xóa Country</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <h6 class="text-danger">Bạn có chác muốn xóa country này?</h6>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                <button type="button" class="btn btn-danger" id="btn-delete-country">
                  Delete
                </button>
              </div>
            </div>
          </div>
        </div>

        <!-- Modal delete department-->
        <div class="modal hide" id="modal-delete-all-country">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-danger">Xóa tất cả country</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <h6 class="text-danger">Bạn có chác muốn xóa country ban này?</h6>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-danger" id="btn-delete-all-country">
                  Delete
                </button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                
              </div>
            </div>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
    <!-- /.content-wrapper -->
  </div>
  </div>
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.1.0
    </div>
  </footer>
  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- jQuery UI 1.11.4 -->
  <script src="plugins/jquery-ui/jquery-ui.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- DataTables  & Plugins -->
  <script src="plugins/datatables/jquery.dataTables.min.js"></script>
  <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
        "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gCountryId = null;
    var gRegionId = null;
    var gTableRegions = $("#region-table").DataTable({
      columns: [
        { data: "id"},
        { data: "regionCode"},
        { data: "regionName"},
        { data: "action"}
      ],
      columnDefs: [
        {
          targets: 3,
          defaultContent: "1"
        }
      ]
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();

    $("#select-country").on("change", function() {
      gCountryId = $("#select-country").val();
      callApiToLoadListRegionWhenSelectCountry();
    })


    // Thực thi sự kiện nhấn vào row click
    $("#region-table").on("click", "tr", function() {
      onRowRegionClick(this);
    })
    // thực thi sự kiện nhấn nút tạo mới country
    $("#create-country").on("click", function() {
      $("#modal-create-country").modal("show");
    });

    // Thực thi sự kiện nhấn nút save data trong modal tạo mới country
    $("#btn-save-country").on("click", function() {
      onBtnCreateNewCountryClick();
    });

    // Thực thi sự kiện nhấn nút update country
    $("#update-country").on("click", function() {
      $("#modal-update-country").modal("show");
      callApiGetCountryDataById();
    });

    // THực thi sự kiện nhấn nút confirm update trong modal
    $("#btn-update-country").on("click", function() {
      onBtnConfirmUpdateCountryClick();
    });

    // Thực thi sự kiện nhất nút delete country
    $("#delete-country").on("click", function() {
      $("#modal-delete-country").modal("show");
    });

    // Thực thi sự kiện nhấn nút delete trong modal delete country
    $("#btn-delete-country").on("click", function() {
      onBtnConfirmDeleteCountryClick();
    });

    // Thực thi sự kiện nhất nút delete all country
    $("#delete-all-country").on("click", function() {
      $("#modal-delete-all-country").modal("show");
    });

    // Thực thi sự kiện nhấn nút delete trong modal delete all country
    $("#btn-delete-all-country").on("click", function() {
      onBtnConfirmDeleteAllCountryClick();
    });

    // Thực thi sự kiện nhấn nút tạo mới region
    $("#create-region").on("click", function() {
      onBtnCreateRegionClick();
    });

    // Thực thi sự kiện nhấn nút cập nhật region
    $("#update-region").on("click", function() {
      onBtnUpdateRegionClick();
    });

    // Thực thi sự kiện nhấn nút delete region
    $("#delete-region").on("click", function() {
      $("#modal-delete-region").modal("show");
    });

    // Thực thi sự kiện nhấn nút delete trong modal delete region
    $("#button-delete-region").on("click", function() {
      onBtnConfirmDeleteRegionClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      callApiToLoadListCountryToSelectCountry();
    }

    // Hàm tạo mới 1 country
    function onBtnCreateNewCountryClick() {
      var vNewCountry = {
        countryCode: "",
        countryName: ""
      }
      getNewCountryData(vNewCountry);
      var vValidate = validateCountry(vNewCountry);
      if(vValidate) {
        callApiToCreateNewCountry(vNewCountry);
      }
    }

    // Hàm xử lý sự kiện nhấn nút xác nhận cập nhật trong modal update country
    function onBtnConfirmUpdateCountryClick() {
      var vCountry = {
        countryCode: "",
        countryName: ""
      }
      getCountryUpdateData(vCountry);
      console.log(vCountry);
      var vValidate = validateCountry(vCountry);
      if(vValidate) {
        callApiToUpdateCountry(vCountry);
      }
    }

    // Hàm xử lý sự kiện nhấn nút delete trong modal xóa 1 country
    function onBtnConfirmDeleteCountryClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/country/" + gCountryId,
        success: function(paramRes) {
          alert("Xóa country thành công!");
          callApiToLoadListCountryToSelectCountry();
          $("#modal-delete-country").modal("hide");
        },
        error: function(paramError) {
          alert("Xóa country thất bại, vui lòng thử lại");
          $("#modal-delete-country").modal("hide");
        }
      });
    }

    // Xàm xử lý sự kiện nhấn nút xác nhận xóa toàn bộ country trong modal
    function onBtnConfirmDeleteAllCountryClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/countries",
        success: function(paramRes) {
          alert("Xóa toàn bộ country thành công!");
          callApiToLoadListCountryToSelectCountry();
          $("#modal-delete-all-country").modal("hide");
        },
        error: function(paramError) {
          alert("Xóa toàn bộ country thất bại, vui lòng thử lại");
          $("#modal-delete-all-country").modal("hide");
        }
      });
    }

    // Hàm xử lý sự kiện nhấn vào row region trong table
    function onRowRegionClick(paramRow) {
      var vDataRow = gTableRegions.row(paramRow).data();
      gRegionId = vDataRow.id;
      loadDataToFormRegion(vDataRow);
    }

    // Hàm xử lý sự kiện nhấn nút tạo mới region
    function onBtnCreateRegionClick() {
      var vRegion = {
        regionName: "",
        regionCode: ""
      }

      getDataRegionForm(vRegion);
      var validate = validateRegion(vRegion);
      if(validate) {
        callApiToCreateNewRegion(vRegion);
      }
    }

    // Hàm xử lý sự kiện nhấn cập nhật region
    function onBtnUpdateRegionClick() {
      var vRegion = {
        regionName: "",
        regionCode: ""
      }

      getDataRegionForm(vRegion);
      var validate = validateRegion(vRegion);
      if(validate) {
        callApiToUpdateRegion(vRegion);
      }
    }

    // Hàm xử lý sự kiện nhấn nút xác nhận xóa region trong modal delete region
    function onBtnConfirmDeleteRegionClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/region/" + gRegionId,
        success: function(paramRes) {
          alert("Xóa region thành công!");
          resetFormRegion();
          callApiToLoadListRegionWhenSelectCountry();
          $("#modal-delete-region").modal("hide");
        },
        error: function(paramError) {
          alert("Xóa region thất bại vui lòng thử lại!");
          $("#modal-delete-region").modal("hide");
          console.log(paramError.status);
        }
      }) 
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callApiToLoadListCountryToSelectCountry() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/countries",
        success: function(paramRes) {
          loadListCountryToSelectCountry(paramRes);
        },
        error: function(paramRes) {
          console.log(paramRes.status);
        }
      });
    }

    // Hàm load vào select country
    function loadListCountryToSelectCountry(paramCountryData) {
      var vSelectCountry = $("#select-country");
      vSelectCountry.html("");
      $("<option>", {
          value: "0",
          text: "Chọn quốc gia"
        }).appendTo(vSelectCountry);
      for(var i = 0; i < paramCountryData.length; i++) {
        $("<option>", {
          value: paramCountryData[i].id,
          text: paramCountryData[i].countryName
        }).appendTo(vSelectCountry);
      }
    }

    // Hàm lấy thông tin country tạo mới trong modal
    function getNewCountryData(paramCountryData) {
      paramCountryData.countryCode = $("#input-country-code").val();
      paramCountryData.countryName = $("#input-country-name").val();
    }
    
    // Hàm validate thông tin country
    function validateCountry(paramCountryData) {
      if(paramCountryData.countryCode == "") {
        alert("Vui lòng nhập mã quốc gia");
        return false;
      }

      if(paramCountryData.countryName == "") {
        alert("Vui lòng nhập tên quốc gia");
        return false;
      }

      return true;
    }

    // Hàm gọi api để tạo mới 1 country
    function callApiToCreateNewCountry(paramCountryData) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/countries",
        contentType: "application/json",
        data: JSON.stringify(paramCountryData),
        success: function(paramRes) {
          alert("Tạo mới quốc gia thành công");
          $("#modal-create-country").modal("hide");
          callApiToLoadListCountryToSelectCountry();
          resetFormCreateCountry();
        },
        error: function(paramError) {
          console.log(paramError.status);
          $("#modal-create-country").modal("hide");
          alert("Tạo mới quốc gia thất bại, vui lòng thử lại");
        }
      });
    }

    // Hàm gọi API để lấy thông tin của country bằng ID sau đó load vào modal update
    function callApiGetCountryDataById() {
      
        $.ajax({
          type: "GET",
          url: "http://localhost:8080/country/" + gCountryId,
          success: function(paramRes) {
            loadDataToModalUpdateCountry(paramRes);
          },
          error: function(paramError) {
            console.log(paramError.status);
          }
        });

    }

    // Hàm load data vào region form
    function loadDataToFormRegion(paramData) {
      $("#input-region-Code").val(paramData.regionCode);
      $("#input-region-name").val(paramData.regionName);
    }

    // Hàm load dữ liệu country vào modal update
    function loadDataToModalUpdateCountry(paramCountryData) {
      $("#input-country-code-update").val(paramCountryData.countryCode);
      $("#input-country-name-update").val(paramCountryData.countryName);
    }

    // Hàm lấy thông tin country tạo mới trong modal
    function getCountryUpdateData(paramCountryData) {
      paramCountryData.countryCode = $("#input-country-code-update").val();
      paramCountryData.countryName = $("#input-country-name-update").val();
    }

    // Hàm gọi API để update thông tin country
    function callApiToUpdateCountry(paramCountryData) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/country/" + gCountryId,
        contentType: "application/json",
        data: JSON.stringify(paramCountryData),
        success: function(paramRes) {
          alert("Cập nhật quốc gia thành công");
          $("#modal-update-country").modal("hide");
          callApiToLoadListCountryToSelectCountry();
        },
        error: function(paramError) {
          console.log(paramError.status);
          $("#modal-update-country").modal("hide");
          alert("Cập nhật quốc gia thất bại, vui lòng thử lại");
        }
      });
    }

    // Hàm reset form trong modal create country
    function resetFormCreateCountry() {
      $("#input-country-code").val("");
      $("#input-country-name").val("");
    }

    // Hàm gọi APi để load list region ra table khi chọn country
    function callApiToLoadListRegionWhenSelectCountry() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/country/" + gCountryId + "/region",
        success: function(paramRes) {
          console.log(paramRes);
          loadRegionDataToTable(paramRes);
        },
        error: function(paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào table
    function loadRegionDataToTable(paramRegionData) {
      gTableRegions.clear();
      gTableRegions.rows.add(paramRegionData);
      gTableRegions.draw();
    }

    // Hàm lấy dữ liệu region từ form
    function getDataRegionForm(paramRegionData) {
      paramRegionData.regionCode = $("#input-region-Code").val();
      paramRegionData.regionName = $("#input-region-name").val();
    }

    // Hàm gọi API để tạo mới 1 region
    function callApiToCreateNewRegion(paramRegionData) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/country/" + gCountryId + "/regions",
        contentType: "application/json", 
        data: JSON.stringify(paramRegionData),
        success: function(paramRes) {
          alert("Tạo mới region thành công!");
          resetFormRegion();
          callApiToLoadListRegionWhenSelectCountry();
        },
        error: function(paramError) {
          alert("Tạo mới region thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      })
    }

    // Hàm reset form region 
    function resetFormRegion() {
      $("#input-region-Code").val("");
      $("#input-region-name").val("");
    }

    function validateRegion(paramRegionData) {
      if(paramRegionData.regionCode == "") {
        alert("Vui lòng nhập region code");
        return false;
      }

      if(paramRegionData.regionName == "") {
        alert("Vui lòng nhập region name");
        return false;
      }
      return true;
    }

    function callApiToUpdateRegion(paramRegionData) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/country/" + gCountryId + "/region/" + gRegionId,
        contentType: "application/json", 
        data: JSON.stringify(paramRegionData),
        success: function(paramRes) {
          alert("Cập nhật region thành công!");
          resetFormRegion();
          callApiToLoadListRegionWhenSelectCountry();
        },
        error: function(paramError) {
          alert("Cập nhật region thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      })
    }
  </script>
</body>

</html>